Attribute VB_Name = "Module1"
' Bildvergleich
' Copyright  2013 by Zardoz

Option Explicit

Private Type BITMAP
  bmType As Long
  bmWidth As Long
  bmHeight As Long
  bmWidthBytes As Long
  bmPlanes As Integer
  bmBitsPixel As Integer
  bmBits As Long
End Type

Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function CompareMemory Lib "ntdll.dll" Alias "RtlCompareMemory" (ByVal Source1 As Any, ByVal Source2 As Any, ByVal Length As Long) As Long

Public Function PictureCompare(Handle1 As Long, Handle2 As Long) As Boolean
  ' Zwei Bilder auf Gleichheit prfen
  
  Dim MapInfo1 As BITMAP, MapInfo2 As BITMAP, NBytes As Long
  
  PictureCompare = False
  If Handle1 = 0 Or Handle2 = 0 Then
    MsgBox "Error: Handle = 0", vbOKOnly + vbExclamation, App.Title
    Exit Function
  End If
  
  ' Bildinfos holen
  Call GetObjectAPI(Handle1, Len(MapInfo1), MapInfo1)
  Call GetObjectAPI(Handle2, Len(MapInfo2), MapInfo2)
  
  With MapInfo1
    ' Breite und Hhe vergleichen
    If .bmWidth = MapInfo2.bmWidth And .bmHeight = MapInfo2.bmHeight Then
      NBytes = .bmHeight * .bmWidthBytes ' Anzahl Bytes
      ' Bilddaten vergleichen
      PictureCompare = (CompareMemory(.bmBits, MapInfo2.bmBits, NBytes) = NBytes)
    End If
  End With
  
End Function
